C ********************************************************************
C * BANDPLOT - Plotting and interpolation of energy bands            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  BPBSRT                                                          *
C *                                                                  *
C *  Routine of BANDPLOT                                             *
C *                                                                  *
C *  Usage......: Sorts bands according to their symmetry info.      *
C *                                                                  *
C *  Authors....: Martin Braendle (mbs)                              *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 06.09.94                                           *
C *  Revision...: 01.07.97/mbs                                       *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: BANDPLOT                                           *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE BPBSRT(IORD,IKSTRT,IKEND,IDIREC,NNOFIT,NBFIT,CSYMRE)
C
C NAG/GKS version.
C
C      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C 
C PGPLOT version.
C
      IMPLICIT REAL(A-H,O-Z)

      INCLUDE 'sizes'

      DIMENSION    IORD(MAXBA,MAXK)
      CHARACTER*32 CCOMP,CSYMRE(MAXBA,MAXK)

C
C Get symmetry ordering information.
C
      IKSRCS=IKSTRT
      DO J=IKSRCS+IDIREC,IKEND,IDIREC
        DO I=NNOFIT+1,NNOFIT+NBFIT
          IORD(I,J)=0
        END DO
      END DO
      DO I=NNOFIT+1,NNOFIT+NBFIT
   10   CCOMP=CSYMRE(I,IKSRCS)
        DO J=IKSRCS+IDIREC,IKEND,IDIREC
          DO K=NNOFIT+1,NNOFIT+NBFIT
            IF ((CCOMP .EQ. CSYMRE(K,J)) .AND.
     .          (IORD(K,J) .EQ. 0)) GOTO 20
          END DO
C
C String not found. It may be a degenerate wave function, so keep
C ordering information and begin search at next k point.
C
          IKSRCS=IKSRCS+IDIREC
          DO K=NNOFIT+1,NNOFIT+NBFIT
            IORD(K,IKSRCS)=K
          END DO  
          IF (IKSRCS .NE. IKEND) GOTO 10
          K=I
C
C String found.
C
   20     IORD(K,J)=I
        END DO
      END DO

      RETURN
      END