C ********************************************************************
C * BANDPLOT - Plotting and interpolation of energy bands            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  TSORT                                                           *
C *                                                                  *
C *  Routine of BFIT (BANDPLOT)                                      *
C *                                                                  *
C *  Usage......: Sorts up to MAXBA bands using up to MAXBA opera-   *
C *               tions.                                             *
C *                                                                  *
C *  Authors....: Sunil Wijeyesekera, Chong Zheng                    *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for Inorg. and Phys. Chemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: -                                                  *
C *  Revision...: 17.02.92/mbs (Martin Braendle), 20.08.92/mbs,      *
C *               02.09.92/mbs, 27.04.93/mbs, 01.07.97/mbs           *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: BFIT                                               *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE TSORT(KPOINT,NBTOT,NK,IDEV)
C
C NAG/GKS version.
C 
C      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C PGPLOT version.
C
      IMPLICIT REAL (A-H,O-Z)
      INCLUDE 'sizes'
 
      PARAMETER (MAXARR=MAXBA*MAXBA)
 
      DIMENSION IA(MAXBA),IB(MAXBA,MAXBA),IC(MAXBA),ID(MAXBA),
     .          IJ(MAXBA),KPOINT(MAXK),IDEV(4)
      DATA IA/MAXBA*0/,IB/MAXARR*0/,IC/MAXBA*0/,ID/MAXBA*0/
 
      DO J=1,NBTOT
        ID(J)=0
      END DO
 
      WRITE(IDEV(4)) (ID(J),J=1,NBTOT)
 
      NLINES=NBTOT/20
 
      READ(IDEV(1),10) KPOINT(1)
   10 FORMAT(I4)
      IF (NLINES .GT. 0) THEN
        DO I=0,NLINES-1
          READ(IDEV(1),20) (IA(J),J=I*20+1,20*(I+1))
   20     FORMAT(20I4)
        END DO
      ENDIF
      IF ((NBTOT-NLINES*20 .GT. 0)) THEN
        READ(IDEV(1),20) (IA(J),J=NLINES*20+1,NBTOT)
      ENDIF
 
      DO K=2,NK
        READ(IDEV(1),10) KPOINT(K)
        IF (NLINES .GT. 0) THEN
          DO I=0,NLINES-1
            READ(IDEV(1),20) (IC(J),J=I*20+1,20*(I+1))
          END DO
        ENDIF
        IF ((NBTOT-NLINES*20 .GT. 0)) THEN
          READ(IDEV(1),20) (IC(J),J=NLINES*20+1,NBTOT)
        ENDIF
        DO J=1,NBTOT
          IR=1
          DO I=1,NBTOT
            IF (J .EQ. IC(I)) THEN
              IB(IR,J)=I
              IR=IR+1
            ENDIF
          END DO
        END DO
        IS=1
        DO I=1,NBTOT
          IJ(I)=1
        END DO
        DO I=1,NBTOT
          DO J=1,NBTOT
            IF (J .EQ. IA(I)) THEN
              IR=IJ(J)
              ID(IS)=IB(IR,J)
              IJ(J)=IJ(J)+1
              IS=IS+1
            ENDIF
          END DO
        END DO
        WRITE(IDEV(4)) (ID(J),J=1,NBTOT)
      END DO
      REWIND IDEV(4)
      RETURN
      END
