C ********************************************************************
C * CEDiT - Crystal Electronic Dipole-induced Transitions            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  SUBROUTINE DDOVL                                                *
C *                                                                  *
C *  Routine of EDiT/CEDiT                                           *
C *  version for IBM-PC MS-DOS, Microsoft FORTRAN and                *
C *              IBM-RISC UNIX, AIX XL FORTRAN                       * 
C *                                                                  *
C *  Usage......: projects the d-d-overlap to the axes. The order    *
C *               of projection is X2-Y2, Z2, XY, XZ, YZ             *
C *                                                                  *
C *  Authors....: Ruedi Rytz                                         *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: July 1992                                          *
C *  Revision...: -                                                  *
C *                                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: PODELE                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE DDOVL(DDOOVL, SIGMA, PI, DELTA, DTR)

      IMPLICIT NONE

        DOUBLE PRECISION DDOOVL(5,5), SIGMA, PI, DELTA, DTR(25)

C VAR
      INTEGER I, J

C BEGIN
      DO 10 I = 1,5
        DO 20 J = 1,5
          DDOOVL(I,J) = DTR(I) * DTR(J) * SIGMA + (DTR(I+5) * DTR(J+5)
     .                  + DTR(I+10) * DTR(J+10)) * PI + (DTR(I+15) *
     .                  DTR(J+15) + DTR(I+20) * DTR(J+20)) * DELTA
20      CONTINUE
10    CONTINUE
     
      RETURN
      END
C END
