C ********************************************************************
C * CEDiT - Crystal Electronic Dipole-induced Transitions            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  SUBROUTINE SPECOUT                                              *
C *                                                                  *
C *  Routine of EDiT/CEDiT                                           *
C *  version for IBM-PC MS-DOS, Microsoft FORTRAN and                *
C *              IBM-RISC UNIX, AIX XL FORTRAN                       *
C *                                                                  *
C *  Usage......: Writes the *.eds files if KEYWRD SPECOUT is        *
C *               selected.                                          *
C *                                                                  *
C *  Authors....: Ruedi Rytz                                         *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: December 1995                                      *
C *  Revision...: November 1998/ calculation of total oscillator     *
C *               strength corrected (line 122)/ stg                 *
C *                                                                  *
C *  Called from: MATRIX                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE SPECOUT(ISPEC, TOL)

      IMPLICIT NONE

      INCLUDE 'sizes'
      INCLUDE 'edconst.inc'

        INTEGER           ISPEC
        DOUBLE PRECISION  TOL

C VAR
      COMMON /TRANS/WAVNUM(MAXTRA), OSCX(MAXTRA), OSCY(MAXTRA),
     .              OSCZ(MAXTRA), DEGEN(MAXAO), COUNTER, INMO(MAXTRA),
     .              FIMO(MAXTRA)
      DOUBLE PRECISION WAVNUM, OSCX, OSCY, OSCZ
      INTEGER DEGEN, COUNTER
      INTEGER INMO, FIMO

      DOUBLE PRECISION TWAV, TOSCX, TOSCY, TOSCZ, TOTOSC
C      DOUBLE PRECISION TOLWAV

      INTEGER I, J, SINMO, SFIMO
C      INTEGER RSTART, REND 

C BEGIN
      DO 10 I = 1, COUNTER
        DO 20 J = I, COUNTER
          IF ( WAVNUM(J) .LT. WAVNUM(I) ) THEN
            TWAV = WAVNUM(J)
            TOSCX = OSCX(J)
            TOSCY = OSCY(J)
            TOSCZ = OSCZ(J)           
            SINMO = INMO(J)
            SFIMO = FIMO(J)
            WAVNUM(J) = WAVNUM(I)
            OSCX(J) = OSCX(I)
            OSCY(J) = OSCY(I)
            OSCZ(J) = OSCZ(I)
            INMO(J) = INMO(I)
            FIMO(J) = FIMO(I)
            WAVNUM(I) = TWAV
            OSCX(I) = TOSCX
            OSCY(I) = TOSCY
            OSCZ(I) = TOSCZ
            INMO(I) = SINMO
            FIMO(I) = SFIMO
          ENDIF
20      CONTINUE
10    CONTINUE

C Uncomment the follwing lines if you wish to sum up degenerate levels!
    
C      TOLWAV = TOL * CM * 2.0D0
C      TOSCX = 0.0D0
C      TOSCY = 0.0D0
C      TOSCZ = 0.0D0
C      RSTART = 1
C      REND = 1

      DO 30 I = 1, COUNTER
C        IF ( DABS(WAVNUM(I+1) - WAVNUM(I)) .LE. TOLWAV ) THEN 
C          REND = REND + 1
C        ELSE 
C          DO 40 J = RSTART, REND
C            TOSCX = TOSCX + OSCX(J)
C            TOSCY = TOSCY + OSCY(J)
C            TOSCZ = TOSCZ + OSCZ(J)
C40        CONTINUE
C          TOTOSC = TOSCX + TOSCY + TOSCZ

          TOTOSC = OSCX(I) + OSCY(I) + OSCZ(I)

C          WRITE (ISPEC, ' (F8.1, 2X, 4(F10.8, 2X), 2(I4,2X)) ' ) 
C     .          WAVNUM(I), TOSCX, TOSCY, TOSCZ, TOTOSC, INMO(I), 
C     .          FIMO(I)

          WRITE (ISPEC, ' (F8.1, 2X, 4(F11.8, 2X), 2(I4,2X)) ' ) 
     .          WAVNUM(I), OSCX(I), OSCY(I), OSCZ(I), TOTOSC, INMO(I), 
     .          FIMO(I)

C          TOSCX = 0.0D0
C          TOSCY = 0.0D0
C          TOSCZ = 0.0D0
C          RSTART = I + 1
C          REND = I + 1 
C        ENDIF
30    CONTINUE

      RETURN
      END
C END
