C ********************************************************************
C * CEDiT - Crystal Electronic Dipole-induced Transitions            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  CHARACTER*(*) FUNCTION TRUNCLS                                  *
C *                                                                  *
C *  Routine of EDiT/CEDiT                                           *
C *  version for IBM-PC MS-DOS, Microsoft FORTRAN and                *
C *              IBM-RISC UNIX, AIX XL FORTRAN                       *
C *                                                                  *
C *  Usage......: Truncates leading spaces.                          * 
C *                                                                  *
C *  Authors....: Ruedi Rytz                                         *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: October 1995                                       *
C *  Revision...:                                                    *
C *                                                                  *
C *  Called from: GETSEL                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

       CHARACTER*(*) FUNCTION TRUNCLS(STRING)

       IMPLICIT NONE

       INCLUDE 'sizes'

         CHARACTER*(4*RECLEN) STRING

C CONST

       CHARACTER*1 SPACE, EQL
       PARAMETER(SPACE = ' ', EQL = '=')

C BEGIN

 10    CONTINUE
         IF ( (STRING(1:1) .EQ. SPACE) .OR.
     .        (STRING(1:1) .EQ. EQL) ) THEN
           STRING = STRING(2:4*RECLEN)
           GOTO 10
         ENDIF 

       TRUNCLS = STRING 

       RETURN
       END
C END
