C ********************************************************************
C * DOSPLOT -  Plots density of states (DOS)                         *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  DPSELC                                                          *
C *                                                                  *
C *  Routine of DOSPLOT                                              *
C *                                                                  *
C *  Usage......: Selects curve for shading or setting line attribu- *
C *               tes or for deleting.                               *
C *                                                                  *
C *  Author.....: Martin Braendle (mbs) c/o                          *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for Inorg. + Phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 28.04.92                                           *
C *  Revision...: 14.08.92/mbs, 18.10.93/mbs, 02.09.94/mbs           *
C *               18.06.97/mbs                                       *
C *  Remarks....: General revision: Selection with mouse cancelled.  *
C *                                                                  *
C *  Called from: DPGRPH                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE DPSELC(DOSMN,DOSMX,COOPMX,IBUFDS,IBUFCP,ILTYPE,ISHADE,
     .                  IBFNDX,IOPT,NMESH,BUFTIT,FARBTR,FCLOSE)
C
C NAG/GKS version.
C 
C      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C
C PGPLOT version.
C
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'sizes'
 
      DIMENSION    ILTYPE(2*MAXBUF),ISHADE(2*MAXBUF),IBFNDX(2*MAXBUF)
      CHARACTER*72 BUFTIT(2*MAXBUF)
      LOGICAL      FCLOSE(2*MAXBUF),FARBTR(2*MAXBUF)
 
      COMMON /BUF/BUFFER(2*MAXBUF*MXMESH),BUFMAX(2*MAXBUF),
     .            BUFMIN(2*MAXBUF)
 
      IF (IOPT .EQ. 0) THEN
        WRITE(6,'('' Select curve to close or open.'')')
      ELSE IF (IOPT .EQ. 1) THEN
        WRITE(6,'('' Select curve for shading.'')')
      ELSE IF (IOPT .EQ. 2) THEN
        WRITE(6,'('' Select curve for changing line attributes.'')')
      ELSE
        WRITE(6,'('' Select curve buffer to delete.'')')
      ENDIF
 
      IF ((IBUFDS .GT. 0) .AND. (IBUFCP .GT. 0)) THEN
   10   WRITE(6,'('' Enter buffer number (DOS, Energies: '',I1,''-'',I2,
     .        '', COOP: '',I1,''-'',I2,''): '',$)') 
     .        1,IBUFDS,MAXBUF+1,MAXBUF+IBUFCP
        READ(5,'(I2)',ERR=10) ISRCH
        IF ((ISRCH .LT. 1) .OR.
     .     ((ISRCH .GT. IBUFDS) .AND. (ISRCH .LT. (MAXBUF+1))) .OR.
     .      (ISRCH .GT. (MAXBUF+IBUFCP))) GOTO 10
      ELSE IF (IBUFDS .GT. 0) THEN
   20   WRITE(6,'('' Enter buffer number (DOS, Energies: '',I1,''-'',I2,
     .        ''): '',$)') 1,IBUFDS
        READ(5,'(I2)',ERR=20) ISRCH
        IF ((ISRCH .LT. 1) .OR. (ISRCH .GT. IBUFDS)) GOTO 20
      ELSE
   30   WRITE(6,'('' Enter buffer number (COOP: '',I2,''-'',I2,''): '',
     .        $)') MAXBUF+1,MAXBUF+IBUFCP
        READ(5,'(I2)',ERR=30) ISRCH
        IF ((ISRCH .LT. (MAXBUF+1)) .OR. (ISRCH .GT. (MAXBUF+IBUFCP)))
     .  GOTO 30
      ENDIF
 
      IF (IOPT .EQ. 0) THEN
        FCLOSE(ISRCH)=.NOT. FCLOSE(ISRCH)
      ELSE IF (IOPT .EQ. 1) THEN
        ISHD=ISHADE(ISRCH)
C
C NAG/GKS version.
C
C        IF (ISHD .GT. 0) ISHD=ISHD-1
        WRITE(6,'('' Brush number of selected curve is '',I2,''.'')') 
     .        ISHD
   40   WRITE(6,'('' Select new brush (0-'',I1,'', 0=no shading): '',
     .        $)') MXBTYP
        READ (5,'(I2)',ERR=40) IBRUSH
        IF ((IBRUSH .LT. 0) .OR. (IBRUSH .GT. MXBTYP)) GOTO 40
C
C Because of unpredictable behaviour of the shade area factor in
C connection with text display brush number 1 is not used.
C
        IF (IBRUSH .GT. 0) THEN
C
C NAG/GKS version.
C
C          IBRUSH=IBRUSH+1
          FCLOSE(ISRCH)=.TRUE.
        ELSE
          FCLOSE(ISRCH)=.FALSE.
        ENDIF
        ISHADE(ISRCH)=IBRUSH
      ELSE IF (IOPT .EQ. 2) THEN
        WRITE(6,'('' Line type number of selected curve is '',I1,
     .        ''.'')') ILTYPE(ISRCH)
   50   WRITE(6,'('' Enter line type (1-'',I1,''): '',$)') MXLTYP
        READ (5,'(I2)',ERR=50) ILINE
        IF ((ILINE .LT. 1) .OR. (ILINE .GT. MXLTYP)) GOTO 50
        ILTYPE(ISRCH)=ILINE
      ELSE
C
C Delete curve.
C
        IF (ISRCH .LE. IBUFDS) THEN
C
C DOS.
C
          IF (ISRCH .LT. IBUFDS) THEN
            DO I=ISRCH+1,IBUFDS
              DO J=1,NMESH
                BUFFER((I-2)*NMESH+J)=BUFFER((I-1)*NMESH+J)
              END DO
              ILTYPE(I-1)=ILTYPE(I)
              ISHADE(I-1)=ISHADE(I)
              IBFNDX(I-1)=IBFNDX(I)
              FCLOSE(I-1)=FCLOSE(I)
              BUFMAX(I-1)=BUFMAX(I)
              BUFMIN(I-1)=BUFMIN(I)
              BUFTIT(I-1)=BUFTIT(I)
            END DO
          ENDIF
          IBUFDS=IBUFDS-1
          DOSMN=1000.
          DOSMX=-1000.
          IF (IBUFDS .GT. 0) THEN
            DO I=1,IBUFDS
              IF (.NOT. FARBTR(I)) THEN
                DOSMN=MIN(DOSMN,BUFMIN(I))
                DOSMX=MAX(DOSMX,BUFMAX(I))
              ENDIF
            END DO
          ENDIF
        ELSE
C
C COOP.
C
          IF (ISRCH .LT. (MAXBUF+IBUFCP)) THEN
            DO I=MAXBUF+ISRCH+1,MAXBUF+IBUFCP
              DO J=1,NMESH
                BUFFER((I-2)*NMESH+J)=BUFFER((I-1)*NMESH+J)
              END DO
              ILTYPE(I-1)=ILTYPE(I)
              ISHADE(I-1)=ISHADE(I)
              IBFNDX(I-1)=IBFNDX(I)
              FCLOSE(I-1)=FCLOSE(I)
              BUFMAX(I-1)=BUFMAX(I)
              BUFMIN(I-1)=BUFMIN(I)
              BUFTIT(I-1)=BUFTIT(I)
            END DO
          ENDIF
          IBUFCP=IBUFCP-1
          COOPMX=-1000.
          IF (IBUFCP .GT. 0) THEN
            DO I=MAXBUF+1,MAXBUF+IBUFCP
              IF (.NOT. FARBTR(I)) COOPMX=MAX(COOPMX,BUFMAX(I))
            END DO
          ENDIF
        ENDIF
      ENDIF
 
      RETURN
      END