C ********************************************************************
C * DOSPLOT -  Plots density of states (DOS)                         *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  DPTITL                                                          *
C *                                                                  *
C *  Routine of DOSPLOT                                              *
C *                                                                  *
C *  Usage......: Sets axes titles.                                  *
C *                                                                  *
C *  Author.....: Martin Braendle (mbs) c/o                          *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 22.04.92                                           *
C *  Revision...: 19.06.97/mbs                                       *
C *  Remarks....: Revision for use with PGPLOT graphics subroutine   *
C *               library.                                           *
C *                                                                  *
C *  Called from: DPGRPH,DOSPLT                                      *
C *                                                                  *
C *  Calls......: DPTRAN,DPTRAP                                      *
C *               PGPLOT routines PGSWIN,PGSVP                       *
C *                                                                  *
C ********************************************************************

      SUBROUTINE DPTITL(VPXDOO,VPXDOW,VPXCOO,VPXCOW,VPXOFF,VPYOFF,
     .                  VPYAXH,IBUFDS,IBUFCP,CDOSTI,CCOPTI,
     .                  CENETI)
C
C NAG/GKS version.
C
C      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C PGPLOT version.
C
      IMPLICIT REAL(A-H,O-Z)

      PARAMETER (MARGIN=0,ILEFT=0,ICENTR=1)

      CHARACTER*80 CDOSTI,CCOPTI,CENETI

      VPYEND=VPYOFF+VPYAXH
C
C Set datarange and viewport.
C
C NAG/GKS version.
C
C      CALL J06WBF(0.0,1.0,0.0,1.0,MARGIN)
C      CALL J06WCF(0.0,1.0,0.0,1.0)
C
C PGPLOT version.
C
      CALL PGSWIN(0.0,1.0,0.0,1.0)
      CALL PGSVP(0.0,1.0,0.0,1.0)
C
C Add title for horizontal DOS plot axis, if existent.
C
      IF (IBUFDS .GT. 0) THEN
        PENX=VPXDOO+VPXDOW*0.5
        PENY=0.5*VPYOFF
C
C NAG/GKS version.
C
C        CALL DPTRAN(CDOSTI,PENX,PENY,ICENTR)
C
C PGPLOT version.
C

        CALL DPTRAP(CDOSTI,PENX,PENY,0.0,ICENTR)
      ENDIF
C
C Add title for horizontal COOP plot axis, if existent.
C
      IF (IBUFCP .GT. 0) THEN
        PENX=VPXCOO+VPXCOW*0.5
        PENY=0.5*VPYOFF
C
C NAG/GKS version.
C
C        CALL DPTRAN(CCOPTI,PENX,PENY,ICENTR)
C
C PGPLOT version.
C
        CALL DPTRAP(CCOPTI,PENX,PENY,0.0,ICENTR)
      ENDIF
C
C Add title for energy axis.
C
C
C NAG/GKS version.
C
C      PENX=0.1*VPXOFF
C      PENY=1.01*VPYEND
C      CALL DPTRAN(CENETI,PENX,PENY,ILEFT)
C
C PGPLOT version.
C
      PENX=0.2*VPXOFF
      PENY=VPYOFF+0.5*VPYAXH
      CALL DPTRAP(CENETI,PENX,PENY,90.,ICENTR)  
      RETURN
      END