C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  BFMO                                                            *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Band fragment orbitals.                            *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 02.05.92/mbs (Martin Braendle, c/o      *
C *               Calzaferri group, Inst. f. Inorg. and Phys. Chem., *
C *               Freiestr. 3, CH-3012 Berne), 16.06.92/mbs          *
C *  Remarks....: Slight modification of COMMON blocks.              *
C *               Formatted output of unit 4.                        *
C *               File access of different operating systems has to  *
C *               be adjusted. Look for OPEN statement.              *
C *                                                                  *
C *  Called from: CRYST                                              *
C *                                                                  *
C *  Calls......: OMF1,OMFRAG,OUTMAT                                 *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE BFMO(D,F,FF,V,ND,NCOUNT,IBLAN,ILAST,LEVE)
 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
 
      INCLUDE 'sizes'
 
      DIMENSION D(ND,ND),F(ND,ND),FF(ND),V(ND,ND)
 
      COMMON /KEYWRD/ KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80
 
      COMMON /FMOIO/IFMOIN(NDIMMX,NFMOMX),IFMOO(NDIMMX,NFMOMX),
     .              NDIMFR(NFMOMX),IFMOP(11,NFMOMX),NFMO
      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
      COMMON /KPIN/TWEI,IKPOPT(MAXOPT+1),NKP
      COMMON /OPTV/RHO,FERMI,WSTART,WEND,DISTL,LB,LE,LBR,LER,IOVLB,
     .             IOVLE,ICHARG,NELEC,IDISTN,IEB,IEE,ISB,ISE,IHB,IHE,
     .             IPOPE,JPOPE,IREST,IRESTV
      COMMON /ORD/IPOSI(NDIMMX)
 
      COMMON /VARGEO/VARINC(NVARMX),IVRLIN(NVARMX),ISTPMX(NVARMX),
     .               IVARTP(NVARMX),ISTEPS(NVARMX),IVARY,NVARY,
     .               NVARLN,NNCPL,LCOUPL(NVARMX+1)
      LOGICAL LCOUPL
 
      JJPOPE=JPOPE
      IF (JJPOPE .EQ. 0) JJPOPE=ND
      NFULL=NELEC/2
      NF=NFULL
      IF (NF*2 .NE. NELEC) NF=NF+1
      IF (JJPOPE .LT. NF) JJPOPE=NF
      IF (LEVE .NE. 0) JJPOPE=LEVE
      REWIND 7
      REWIND 11
C
C order C imag.
C
      DO 20 J=1,ND
        DO 10 I=1,ND
          IOLD=IPOSI(I)
          F(I,J)=V(IOLD,J)
   10   CONTINUE
   20 CONTINUE
C
C store C imag.
C
      READ(7)
      WRITE(7) F
C
C order C real
C
      DO 40 J=1,ND
        DO 30 I=1,ND
          IOLD=IPOSI(I)
          V(I,J)=D(IOLD,J)
   30   CONTINUE
   40 CONTINUE
C
C *********************************************************************
C co vs fmo  C=C'T  :  T=C'^S'C
C *********************************************************************
C (C'^S' is present in file 7 (see subroutine ehfmo))
C
C calculate T real
C
      REWIND 7
      READ(7) F
      DO 70 I=1,ND
        DO 60 J=1,ND
          D(J,I)=0.0
          DO 50 K=1,ND
            D(J,I)=D(J,I)+F(J,K)*V(K,I)
   50     CONTINUE
   60   CONTINUE
   70 CONTINUE
C
C store T real and read C imag.
C
      READ(7) V
      REWIND 7
      WRITE(7) D
      REWIND 7
C
C calculate T imag.
C
      DO 100 I=1,ND
        DO 90 J=1,ND
          D(J,I)=0.0
          DO 80 K=1,ND
            D(J,I)=D(J,I)+F(J,K)*V(K,I)
   80     CONTINUE
   90   CONTINUE
  100 CONTINUE
C
C read T real
C
      READ(7) V
      REWIND 7
C
C store C' and T (real,imag.)
C
      WRITE(7) F
      WRITE(7) V
      WRITE(7) D
      REWIND 7
C
C T output
C
      IF (IKPOPT(4) .NE. 0) THEN
        WRITE(IOUT,110)
  110   FORMAT(//,'     Orbital vectors in terms of fragments',/)
        IBLAN=1
        CALL OMF1(V,D,ND)
      ENDIF
C
C *********************************************************************
C fmo charge matrix  Qai=2T"ai * \C'^(SC)\ai
C *********************************************************************
C
C 1) calculate SC
C read C imag. and S
C
      REWIND 23
      READ(23)
      READ(23)
      READ(23) V
      REWIND 23
      READ(23) F
C
C calculate S imag. * C imag.
C
      DO 160 K=1,ND
        DO 150 I=1,ND
          D(I,K)=0.0
          IF (I .EQ. ND) GOTO 130
          IX=I+1
          DO 120 J=IX,ND
            D(I,K)=D(I,K)+F(I,J)*V(J,K)
  120     CONTINUE
  130     IF (I .EQ. 1) GOTO 150
          IY=I-1
          DO 140 J=1,IY
            D(I,K)=D(I,K)-F(J,I)*V(J,K)
  140     CONTINUE
  150   CONTINUE
  160 CONTINUE
C
C read C real
C
      READ(23) V
C
C calculate S real * C real
C
      DO 200 K=1,ND
        DO 190 I=1,ND
          DO 170 J=I,ND
  170     D(I,K)=D(I,K)+F(J,I)*V(J,K)
          IF (I .EQ. 1) GOTO 190
          I1=I-1
          DO 180 J=1,I1
            D(I,K)=D(I,K)+F(I,J)*V(J,K)
  180     CONTINUE
  190   CONTINUE
  200 CONTINUE
C
C order SC real
C
      DO 220 J=1,ND
        DO 210 I=1,ND
          IOLD=IPOSI(I)
          V(I,J)=D(IOLD,J)
  210   CONTINUE
  220 CONTINUE
C
C store SC real
C
      READ(11)
      WRITE(11) V
C
C read C real
C
      REWIND 23
      READ(23)
      READ(23) V
C
C calculate S imag. * C real
C
      DO 270 K=1,ND
        DO 260 I=1,ND
          D(I,K)=0.0
          IF (I .EQ. ND) GOTO 240
          IX=I+1
          DO 230 J=IX,ND
            D(I,K)=D(I,K)-F(I,J)*V(J,K)
  230     CONTINUE
  240     IF (I .EQ. 1) GOTO 260
          IY=I-1
          DO 250 J=1,IY
            D(I,K)=D(I,K)+F(J,I)*V(J,K)
  250     CONTINUE
  260   CONTINUE
  270 CONTINUE
C
C read C imag.
C
      READ(23) V
      REWIND 23
C
C calculate S real * C imag.
C
      DO 310 K=1,ND
        DO 300 I=1,ND
          DO 280 J=I,ND
  280     D(I,K)=D(I,K)+F(J,I)*V(J,K)
          IF (I .EQ. 1) GOTO 300
          I1=I-1
          DO 290 J=1,I1
  290     D(I,K)=D(I,K)+F(I,J)*V(J,K)
  300   CONTINUE
  310 CONTINUE
C
C order SC imag.
C
      DO 330 J=1,ND
        DO 320 I=1,ND
          IOLD=IPOSI(I)
          F(I,J)=D(IOLD,J)
  320   CONTINUE
  330 CONTINUE
C
C store SC imag.
C
      WRITE(11) F
      REWIND 11
C
C 2) calculate Q
C
C read C'
C
      READ(11) D
C
C calculate C'^(SC) imag.
C
      DO 360 J=1,JJPOPE
        DO 350 I=1,ND
          V(I,J)=0.0
          DO 340 K=1,ND
            V(I,J)=V(I,J)+D(K,I)*F(K,J)
  340     CONTINUE
  350   CONTINUE
  360 CONTINUE
C
C read T imag.
C
      READ(7)
      READ(7)
      READ(7) F
C
C calculate Q1  from imag.
C
      DO 380 J=1,JJPOPE
        DO 370 I=1,ND
          V(I,J)=V(I,J)*F(I,J)
  370   CONTINUE
  380 CONTINUE
C
C store Q1
C
      WRITE(7) V
      REWIND 7
C
C read SC real
C
      READ(11) V
      DO 410 J=1,ND
        DO 400 I=1,ND
          F(I,J)=0.0
          DO 390 K=1,ND
            F(I,J)=F(I,J)+D(K,I)*V(K,J)
  390     CONTINUE
  400   CONTINUE
  410 CONTINUE
C
C read T real
C
      READ(7)
      READ(7) V
C
C calculate Q2  from real
C
      DO 430 J=1,ND
        DO 420 I=1,ND
          F(I,J)=V(I,J)*F(I,J)
  420   CONTINUE
  430 CONTINUE
C
C read Q1
C
      READ(7)
      READ(7) V
      REWIND 7
C
C calculate Q
C
      DO 450 J=1,JJPOPE
        DO 440 I=1,ND
          F(I,J)=2.0D0*(F(I,J)+V(I,J))
  440   CONTINUE
  450 CONTINUE
C
C MSDOS-version: add FILE='fort.4' to OPEN statement
C AIX-version: delete FILE='fort.4', compile with option
C              -qposition=append
C VMS-version: delete FILE='fort.4'
C
      IF ((NCOUNT .EQ. 1) .AND. (IVARY .EQ. 1)) THEN
        OPEN (UNIT=4,FILE='fort.4',FORM='formatted',STATUS='new')
      ELSE
C
C MSDOS-version: add ACCESS='APPEND' and FILE='fort.4' to OPEN
c                statement.
C AIX-version: delete ACCESS='APPEND' and FILE='fort.4', compile with
C              option -qposition=append
C VMS-version: delete ACCESS='APPEND' and FILE='fort.4'
C
        OPEN (UNIT=4,FILE='fort.4',FORM='formatted',STATUS='unknown',
     .        ACCESS='append')
      ENDIF
      WRITE(4,451) JJPOPE
  451 FORMAT(I6)
      DO 455 I=1,ND
        WRITE(4,452) (F(I,J),J=1,JJPOPE)
  452   FORMAT(F8.5)
  455 CONTINUE
      CLOSE(4)
 
      IF (IKPOPT(5) .NE. 0) THEN
        WRITE(IOUT,460)
  460   FORMAT(//,5X,'FMO charge matrix for each CO, normalized ',
     .         'to two electrons',/)
        IBLAN=1
        CALL OMFRAG(F,ND)
      ENDIF
 
      IF (IKPOPT(6) .EQ. 0) RETURN
C
C **********************************************************************
C reduced fmo charge matrix
C **********************************************************************
C
      M1=1
      M2=0
      DO 490 I=1,NFMO
        M2=M2+NDIMFR(I)
        DO 480 J=1,JJPOPE
          V(I,J)=0.0
          DO 470 K=M1,M2
            V(I,J)=V(I,J)+F(K,J)
  470     CONTINUE
  480   CONTINUE
        M1=M1+NDIMFR(I)
  490 CONTINUE
C
C output
C
      WRITE(IOUT,500)
  500 FORMAT(//,5X,'Reduced FMO charge matrix for each CO,',
     .       ' fragment in rows',/)
      IBLAN=1
      LEE=LE
      IF ((LEE .GT. ILAST) .AND. (ILAST .NE. 0)) LEE=ILAST
      CALL OUTMAT(V,ND,1,NFMO,LB,LEE,1,1)
C
C charge on fragments
C
      FULL=NELEC/2.0D0
      IF (ILAST .EQ. 0) THEN
        WRITE(IOUT,510) FULL
  510   FORMAT(//,5X,'Charges on fragments for occupation = ',F5.1,
     .         ' (fermi level unknown)',/)
      ELSE
        FULL=DBLE(ILAST)
        WRITE(IOUT,520) FULL,FERMI
  520   FORMAT(//,5X,'Charges on fragments for occupation = ',F5.1,
     .         ' corresponding to fermi level = ',F10.6/)
      ENDIF
      IF (ILAST .NE. 0) NFULL=ILAST
      DO 550 I=1,NFMO
        FF(I)=0.0
        DO 530 J=1,NFULL
          FF(I)=FF(I)+V(I,J)
  530   CONTINUE
        IF ((NELEC .NE. NFULL*2) .AND. (ILAST .EQ. 0)) THEN
          FF(I)=FF(I)+0.5*V(I,J+1)
        ENDIF
        WRITE(IOUT,540) I,FF(I)
  540   FORMAT(10X,I3,F12.6)
  550 CONTINUE
      RETURN
      END
