C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  BPOP                                                            *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Prepares files for the AOPOP and OVLPOP calcula-   *
C *               tion.                                              *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 09.04.92/mbs (Martin Braendle, c/o      *
C *               Calzaferri group, Inst. f. Inorg. and Phys. Chem., *
C *               Freiestr. 3, CH-3012 Berne                         *
C *  Remarks....: Generates formatted output.                        *
C *               File access of different operating systems has to  *
C *               be adjusted. Look for OPEN statements.             *
C *                                                                  *
C *  Called from: CRYST                                              *
C *                                                                  *
C *  Calls......: OMATT,MOPOP1,POBOND                                *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE BPOP(D,DD,F,P,DEN,NDIM,NCOUNT,IBLAN,JLAST,LEVS,LEVE)
 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
 
      INCLUDE 'sizes'
 
      DIMENSION D(NDIM,NDIM),DD(NDIM),F(NDIM,NDIM),P(NDIM,NDIM),
     .          DEN(NDIM,NDIM),PK(NBONMX)
 
 
      COMMON /AOOUT1/INDTS(NDIMMX)
 
      COMMON /ATO/AC(NATMMX),SYMBOL(NSYMMX)
      CHARACTER AC*7,SYMBOL*2
 
      COMMON /ATOM1/NS(NSYMMX,NAEQMX),NP(NSYMMX),ND(NSYMMX),NF(NSYMMX),
     .              INATOM, ISYM(NATMMX),NELEM
 
      COMMON /BOND1/IDAT(NBONMX,2)
      CHARACTER*7 IDAT
 
      COMMON /BOND2/IDTR(NBONMX,3),DDX(NBONMX),IDBOND,INEXT(NBONMX),
     .              IFIRST,ITYPE(14)
 
      COMMON /INDX/NCRYST,NCEL1,NCEL2,NCEL3,XK(3),WEIGHT,TWOPI,ND1,
     .             NGRAD,NFULL,CEL1,CEL2
      LOGICAL CEL1,CEL2
 
      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
      COMMON /KPIN/TWEI,IKPOPT(MAXOPT+1),NKP
 
      COMMON /KEYWRD/KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80
 
      COMMON /OPTV/RHO,FERMI,WSTART,WEND,DISTL,LB,LE,LBR,LER,IOVLB,
     .             IOVLE,ICHARG,NELEC,IDISTN,IEB,IEE,ISB,ISE,IHB,IHE,
     .             IPOPE,JPOPE,IREST,IRESTV
 
      COMMON /POP/X,Y,SORB
      INTEGER SORB(NATMMX)
 
      COMMON /VARGEO/VARINC(NVARMX),IVRLIN(NVARMX),ISTPMX(NVARMX),
     .               IVARTP(NVARMX),ISTEPS(NVARMX),IVARY,NVARY,
     .               NVARLN,NNCPL,LCOUPL(NVARMX+1)
      LOGICAL LCOUPL
 
 
      IIPOPE=IPOPE
      IF (IIPOPE .EQ. 0) IIPOPE=NDIM
      NFULL=NELEC/2
      NF1=NFULL
      IF (NF1*2 .NE. NELEC) NF1=NF1+1
      IF (IIPOPE .LT. NF1) IIPOPE=NF1
      IF (LEVE .NE. 0) IIPOPE=LEVE
 
      IAOPOP=INDEX(KEYWRD,'AOPOP')
      IOPOP=INDEX(KEYWRD,'OVLPOP')
      IF (IAOPOP .EQ. 0) GOTO 170
C
C charge matrix : Qai=2C"ai * \SC\a
C
C read S, C real and imag.
C
      REWIND 23
      READ(23) F
      READ(23) D
      READ(23) P
      REWIND 23
C
C calculate Qai
C
      DO 50 K=1,IIPOPE
        DO 40 I=1,NDIM
          X=0.0D0
          Y=0.0D0
          DO 10 J=I,NDIM
            X=X+F(J,I)*D(J,K)+(1.0D0-DBLE(I)/DBLE(J))*F(I,J)*P(J,K)
            Y=Y+F(J,I)*P(J,K)-(1.0D0-DBLE(I)/DBLE(J))*F(I,J)*D(J,K)
   10     CONTINUE
 
          IF (I .EQ. 1) GOTO 30
          I1=I-1
          DO 20 J=1,I1
            X=X+F(I,J)*D(J,K)-F(J,I)*P(J,K)
            Y=Y+F(I,J)*P(J,K)+F(J,I)*D(J,K)
   20     CONTINUE
   30     CONTINUE
          DD(I)=2.0*(X*D(I,K)+Y*P(I,K))
   40   CONTINUE
        WRITE(9) DD
   50 CONTINUE
      REWIND 9
 
      DO 60 K=1,IIPOPE
        READ(9) (P(I,K),I=1,NDIM)
   60 CONTINUE
      REWIND 9
C
C VMS- and AIX-version: Remove FILE='fort.2' from OPEN statement.
C MS-DOS-version: Add FILE='fort.2' to OPEN statement.
C
      IF ((NCOUNT .EQ. 1) .AND. (IVARY .EQ. 1)) THEN
        OPEN (UNIT=2,FORM='formatted',STATUS='new',FILE='fort.2')
      ELSE
C
C VMS- and AIX-version: Remove FILE='fort.2' and ACCESS='append' from
C                       OPEN statement.
C MS-DOS-version: Add FILE='fort.2' and ACCESS='append' to OPEN
C                 statement.
C
        OPEN (UNIT=2,FORM='formatted',STATUS='unknown',FILE='fort.2',
     .        ACCESS='append')
      ENDIF
      WRITE(2,61) IIPOPE
   61 FORMAT(I6)
      DO 65 I=1,NDIM
        WRITE(2,62) (P(I,J),J=1,IIPOPE)
   62   FORMAT(F10.5)
   65 CONTINUE
      CLOSE(2)
 
      IF (IKPOPT(2) .NE. 0) THEN
        WRITE(IOUT,70)
   70   FORMAT(//,5X,'Complete charge matrix for each CO, normalized',
     .         ' to two electrons',/)
        IBLAN=1
        LEE=LE
        IF ((LEE .GT. JLAST) .AND. (JLAST .NE. 0)) LEE=JLAST
        CALL OMATT(P,NDIM,LBR,LER,LB,LEE,INDTS,1)
      ENDIF
 
      IF (IKPOPT(3) .EQ. 0) GOTO 170
C
C reduced charge matrix
C
C read S
C
      READ(21) (SORB(I),I=1,INATOM)
      SORB(INATOM+1)=SORB(1)+NDIM
      REWIND 21
 
      I=1
   80 MA=SORB(I)
      NA=SORB(I+1)-1
      DO 100 K=1,IIPOPE
        D(I,K)=0.0
        DO 90 J=MA,NA
          D(I,K)=D(I,K)+P(J,K)
   90   CONTINUE
  100 CONTINUE
      I=I+1
      IF (I .LE. INATOM) GOTO 80
C
C     print reduced charge matrix
C
      WRITE(IOUT,110)
  110 FORMAT(//,5X,'Reduced charge matrix for each CO')
      IBLAN=1
      LEE=LE
      IF ((LEE .GT. JLAST) .AND. (JLAST .NE. 0)) LEE=JLAST
      CALL MOPOP1(D,NDIM,1,INATOM,LB,LEE,1,1)
 
      IF (JLAST .NE. 0) NFULL=JLAST
      FULL=DBLE(NELEC)/2.0D0
      IF (JLAST .EQ. 0) THEN
        WRITE(IOUT,120) FULL
  120   FORMAT(//,5X,'Charge on atoms for occupation=',F5.1,
     .         ' (fermi level unknown)',/)
      ELSE
        FULL=DBLE(JLAST)
        WRITE(IOUT,130) FULL,FERMI
  130   FORMAT(//,5X,'Charge on atoms for occupation = ',F5.1,
     .         ' corresponding to fermi level = ',F10.6,/)
      ENDIF
 
      DO 150 I=1,INATOM
        DD(I)=0.0D0
        DO 140 K=1,NFULL
          DD(I)=DD(I)+D(I,K)
  140   CONTINUE
        IF ((NFULL*2 .NE. NELEC) .AND. (JLAST .EQ. 0))
     .    DD(I)=DD(I)+0.5D0*D(I,K+1)
        WRITE(IOUT,160) AC(I),DD(I)
  150 CONTINUE
  160 FORMAT(10X,A7,2X,F12.6)
C
C this part calculates the density matrix with the occupation iovlb
C
  170 IF (IOPOP .EQ. 0) RETURN
 
      IF (IKPOPT(7) .NE. 0) THEN
        WRITE(IOUT,180)
  180   FORMAT(//,5X,'Cumulated reduced overlap population')
        IBLAN=1
      ENDIF
C
C calculate number of non equiv. bonds
C
      IF (NCOUNT .GT. 1) GOTO 210
      NEQU=1
      IRUN=1
      LOQ=IFIRST
      IF (INEXT(IFIRST) .GT. 10000) THEN
        ILAST=1
      ELSE
        ILAST=0
      ENDIF
  190 IF (ILAST .EQ. 1) THEN
        NEQU=NEQU+1
        ILAST=0
      ENDIF
      IRUN=IRUN+1
      IF (IRUN .GT. IDBOND) GOTO 200
      LOQ=INEXT(LOQ)
      IF (LOQ .GT. 10000) LOQ=LOQ-10000
      IF (INEXT(LOQ) .GT. 10000) ILAST=1
      GOTO 190
  200 NEQU=NEQU-1
C
C calculate interval of integration
C
  210 JOVLB=IOVLB
      JOVLE=IOVLE
      IWIND=INDEX(KEYWRD,'WINDOW')
      IF (IWIND .NE. 0) THEN
        JOVLB=LEVS
        JOVLE=LEVE
      ENDIF
      IF (JOVLB .LE. 1) JOVLB=2
      IF (JOVLE .EQ. 1) JOVLE=2
      IF (JOVLE .EQ. 0) JOVLE=NDIM
      IF (JOVLE .GT. NDIM) JOVLE=NDIM
      IF (JOVLB .GT. JOVLE) JOVLB=JOVLE
      KU=JOVLB-1
      KL=1
C
C headline of file 3
C
C
C VMS- and AIX-version: Remove FILE='fort.3' from OPEN statements.
C MS-DOS-version: Add FILE='fort.3' to OPEN statements.
C
      IF (NCOUNT .EQ. 1) THEN
        IF (IVARY .EQ. 1) THEN
          OPEN (UNIT=3,FORM='formatted',STATUS='new',FILE='fort.3')
        ELSE
          OPEN (UNIT=3,FORM='formatted',STATUS='unknown',FILE='fort.3')
        ENDIF
        WRITE(3,212) NEQU
212     FORMAT(I4)
  
      ENDIF
C
C VMS- and AIX-version: Remove FILE='fort.3' and ACCESS='append' from
C                       OPEN statement.
C MS-DOS-version: Add FILE='fort.3' and ACCESS='append' to OPEN
C                 statement.
C
      OPEN (UNIT=3,FORM='formatted',STATUS='unknown',FILE='fort.3',
     .      ACCESS='append')
      WRITE(3,215) JOVLB,JOVLE
215   FORMAT(2I4)
C
C loop start
C
      JLOO=0
  220 CONTINUE
      JLOO=JLOO+1
C
C read C real and imag.
C
      READ(23)
      READ(23) D
      READ(23) P
      REWIND 23
 
      DO 230 I=1,NDIM
        DO 230 J=1,NDIM
          DEN(I,J)=0.0D0
  230 CONTINUE
      DO 250 I=1,NDIM
        DO 250 J=I,NDIM
          DO 240 K=KL,KU
            DEN(J,I)=DEN(J,I)+2.0D0*(D(I,K)*D(J,K)+P(I,K)*P(J,K))
            DEN(I,J)=DEN(I,J)+2.0D0*(D(I,K)*P(J,K)-D(J,K)*P(I,K))
  240     CONTINUE
  250 CONTINUE
 
      IF (IKPOPT(7) .EQ. 0) GOTO 280
      IF (KL .NE. KU) WRITE(IOUT,260) KL,KU
  260   FORMAT(//,5X,'for band level ',I3,' to band level ',I3,/)
      IF (KL .EQ. KU) WRITE(IOUT,270) KL
  270  FORMAT(//,5X,'for band level ',I3,/)
 
  280 REWIND 21
      REWIND 19
      READ(21) (SORB(I),I=1,INATOM),D
      DO 290 I=1,IDBOND
        PK(I)=0.0D0
  290 CONTINUE
C
C in the unit cell
C
      ID=1
      IT=1
      IF (ITYPE(1) .NE. 0) CALL POBOND(PK,D,P,DEN,NDIM,IT,ID)
C
C between unit cell and cell at +1x
C
      IT=2
      X=DCOS(XK(1))
      Y=DSIN(XK(1))
      IF (ITYPE(2) .NE. 0) THEN
        READ(19) D
        CALL POBOND(PK,D,P,DEN,NDIM,IT,ID)
      ELSE
        READ(19)
      ENDIF
      IF (NCRYST .EQ. 1) GOTO 315
C
C between unit cell and cell at +1y
C
      IT=3
      X=DCOS(XK(2))
      Y=DSIN(XK(2))
      IF (ITYPE(3) .NE. 0) THEN
        READ(19) D
        CALL POBOND(PK,D,P,DEN,NDIM,IT,ID)
      ELSE
        READ(19)
      ENDIF
C
C between unit cell and cell at +1x +1y
C
      IT=4
      X=DCOS(XK(1)+XK(2))
      Y=DSIN(XK(1)+XK(2))
      IF (ITYPE(4) .NE. 0) THEN
        READ(19) D
        CALL POBOND(PK,D,P,DEN,NDIM,IT,ID)
      ELSE
        READ(19)
      ENDIF
C
C between unit cell and cell at +1x -1y
C
      IT=5
      X=DCOS(XK(1)-XK(2))
      Y=DSIN(XK(1)-XK(2))
      IF (ITYPE(5) .NE. 0) THEN
        READ(19) D
        CALL POBOND(PK,D,P,DEN,NDIM,IT,ID)
      ELSE
        READ(19)
      ENDIF
      IF (NCRYST .EQ. 2) GOTO 315
C
C between unit cell and cell at +ix +jy +kz (i=-1,0,1) (j=-1,0,1)
C
      DO 310 I=-1,1
        RI=DBLE(I)
        DO 300 J=-1,1
          RJ=DBLE(J)
          IT=IT+1
          X=DCOS(RI*XK(1)+RJ*XK(2)+XK(3))
          Y=DSIN(RI*XK(1)+RJ*XK(2)+XK(3))
          IF (ITYPE(IT) .NE. 0) THEN
            READ(19) D
            CALL POBOND(PK,D,P,DEN,NDIM,IT,ID)
          ELSE
            READ(19)
          ENDIF
  300   CONTINUE
  310 CONTINUE
C
C initialization
C
  315 DO 320 I=1,IDBOND
        DD(I)=0.0D0
  320 CONTINUE
 
      NONEQU=1
      IRUN=1
      NDIVIS=1
      LOQ=IFIRST
      IF (INEXT(IFIRST) .GT. 10000) THEN
        ILAST=1
      ELSE
        ILAST=0
      ENDIF
 
  330 DD(NONEQU)=DD(NONEQU)+PK(LOQ)
      IF (ILAST .EQ. 1) THEN
        IF (IKPOPT(7) .NE. 0) THEN
          WRITE(IOUT,340) NONEQU,IDAT(LOQ,1),IDAT(LOQ,2),DDX(LOQ),
     .                    DD(NONEQU),NDIVIS
  340     FORMAT(1X,I4,3X,A7,' <---> ',A7,'   dist=',F10.5,'  ovlpop=',
     .           F10.5,'  for ',I3,' bonds')
        ENDIF
        IF ((NCOUNT .EQ. 1) .AND. (JLOO .EQ. 1)) THEN
          WRITE(3,345) IDAT(LOQ,1),IDAT(LOQ,2),DDX(LOQ),NDIVIS
  345     FORMAT(2A7,F10.5,I4)
        ENDIF
        NONEQU=NONEQU+1
        ILAST=0
        NDIVIS=0
      ENDIF
      IRUN=IRUN+1
      NDIVIS=NDIVIS+1
      IF (IRUN .GT. IDBOND) GOTO 350
      LOQ=INEXT(LOQ)
      IF (LOQ .GT. 10000) LOQ=LOQ-10000
      IF (INEXT(LOQ) .GT. 10000) ILAST=1
      GOTO 330
 
  350 CONTINUE
      WRITE(3,355) (DD(I),I=1,NONEQU-1)
  355 FORMAT(F8.5)
C
C next loop
C
      KU=KU+1
      KL=KU
      IF (KU .LE. JOVLE) GOTO 220
      REWIND 21
      CLOSE(3)
      RETURN
      END
