#!/bin/ksh
#
# @(#) ehmacc_batch V1.0 - perform ehmacc bandstructure job
# 
# Author  : Martin Braendle, Spiez (mbs)
# Date    : 29.10.93/mbs 
# Revision: Ruedi Rytz, January 1996
# Remarks : We want to move the *.kpe files, too (KEYWRD EDITOUT)
#------------------------------------------------------------------------------
#
read filename <inputfile
nice -n 20 $BANDDIR/ehmaccS.exe <$filename.ehi >fort.6 ;
if (test -r fort.1)
then
  mv fort.1 ../$filename.eh1
fi
if (test -r fort.2)
then
  mv fort.2 ../$filename.eh2
fi
if (test -r fort.3)
then
  mv fort.3 ../$filename.eh3
fi
if (test -r fort.4)
then
  mv fort.4 ../$filename.eh4
fi
if (test -r fort.6)
then
  mv fort.6 ../$filename.eho
fi
if (test -r fort.8)
then
  mv fort.8 ../$filename.ehc
fi 
if (test -r fort.10)
then
  mv fort.10 ../$filename.k-points
fi
if (test -r fort.14)
then
  mv fort.14 ../$filename.ehe
fi
if (test -r fort.15)
then
  mv fort.15 ../$filename.ene
fi
if (test -r ehmacc.s*)
then
  rm ehmacc.s*
fi
mv $filename.ehi ..
rm inputfile
#
# Extension for CEDiT/rr
#
if (test -e 001.kpe)
then
  for i in *.kpe
  do
    mv $i ../$i
  done
fi
cd ..
rmdir $filename
#(EOF)
