C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  OMATAT                                                          *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Output of atomic matric elements (e.g. kappa).     *
C *                                                                  *
C *  Author.....: Martin Braendle (mbs)                              *
C *  Available..: Calzaferri group c/o Prof. G. Calzaferri, Inst. f. *
C *               Inorg. and Phys. Chemistry, Freiestr. 3, Univerity *
C *               of Berne, CH-3012 Berne                            *
C *  Date.......: 18.02.93/mbs                                       *
C *  Revision...: -                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: GETKD                                              *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE OMATAT(Z,NN,LBR,LER,LB,LE)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      INCLUDE 'sizes'

      DIMENSION Z(NN,NN)

      COMMON /IOUNIT/IIN,IOUT,ISTART(40)

      COMMON /ATO/AC(NATMMX),SYMBOL(NSYMMX)
      CHARACTER AC*7,SYMBOL*2

      IFLAG=1
      ILOWER=LB

   10 IUPPER=ILOWER+13
      IF (IUPPER-LE) 30,20,20
   20 IUPPER=LE
      IFLAG=0
   30 WRITE(IOUT,40) (J,J=ILOWER,IUPPER)
   40 FORMAT(/,14X,14(3X,I3,3X))
      WRITE(IOUT,50) (AC(J),J=ILOWER,IUPPER)
   50 FORMAT(14X,14(1X,A7,1X))
      WRITE(IOUT,60)
   60 FORMAT(' ')

      IL1=ILOWER
      IU1=IUPPER

      DO 80 I=LBR,LER
        WRITE(IOUT,70) I,AC(I),(Z(I,J),J=IL1,IU1)
   70   FORMAT(1X,I4,1X,A7,1X,14(1X,F8.4))
   80 CONTINUE

      IF (IFLAG) 90,100,90
   90 ILOWER=ILOWER+14
      GOTO 10

  100 WRITE(IOUT,110)
  110 FORMAT(//)
      RETURN
      END
