C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  UNIQUE                                                          *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......:                                                    *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987                                          *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: SMAT,HMAT                                          *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE UNIQUE(S,ND,NLIM,IWR)
 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      DIMENSION S(ND,ND)

      ND1=NLIM-1
      DO 20 M=1,ND1
        MA=M+1
        DO 10 N=MA,NLIM
          S(N,M)=0.5D0*(S(N,M)-S(M,N))
          S(M,N)=S(N,M)+S(M,N)
   10   CONTINUE
        S(M,M)=0.5D0*S(M,M)
   20 CONTINUE
      S(NLIM,NLIM)=0.5D0*S(NLIM,NLIM)

      IF (IWR .NE. 0) WRITE(19) ((S(I,J),I=1,NLIM),J=1,NLIM) 

      RETURN
      END
