C ********************************************************************
C * EHMACC - Extended Hueckel Molecular and Crystal Calculations     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  VARYGM                                                          *
C *                                                                  *
C *  Routine of EHMACC                                               *
C *                                                                  *
C *  Usage......: Varies coordinates of a structure.                 *
C *                                                                  *
C *  Author.....: Martin Braendle (mbs)                              *
C *  Available..: Calzaferri group, Institute for Inorganic and Phy- *
C *               sical Chemistry, Freiestr. 3, CH-3012 Berne,       *
C *               Switzerland                                        *
C *  Date.......: 06.07.1994                                         *
C *  Revision...: 14.11.1994                                         *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: PART1,PART2                                        *
C *                                                                  *
C *  Calls......: BUILDZ,FTOCAR,INMODI                               *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE VARYGM
 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
 
      INCLUDE 'sizes'
 
      LOGICAL VARIED
 
      COMMON /ATOM2/EXPS(NSYMMX,NAEQMX),EXPS2(NSYMMX,NAEQMX),
     .              EXPP(NSYMMX),EXPP2(NSYMMX),
     .              EXPD(NSYMMX),EXPD2(NSYMMX),
     .              EXPF(NSYMMX),EXPF2(NSYMMX),
     .              CS1(NSYMMX,NAEQMX),CS2(NSYMMX,NAEQMX),
     .              CP1(NSYMMX),CP2(NSYMMX),CD1(NSYMMX),CD2(NSYMMX),
     .              CF1(NSYMMX),CF2(NSYMMX),COULS(NSYMMX,NAEQMX),
     .              COULP(NSYMMX),COULD(NSYMMX),COULF(NSYMMX),
     .              C(NATMMX,3)
 
      COMMON /FRACTC/FC(NATMMX,3)

      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
 
      COMMON /KEYWRD/KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80
 
      COMMON /LATCON/ALAT,BLAT,CLAT,ALPLAT,BETLAT,GAMLAT

      COMMON /VARGEO/VARINC(NVARMX),IVRLIN(NVARMX),ISTPMX(NVARMX),
     .               IVARTP(NVARMX),ISTEPS(NVARMX),IVARY,NVARY,
     .               NVARLN,NNCPL,LCOUPL(NVARMX+1)
      LOGICAL LCOUPL
 
      COMMON /ZMAT/BL(NATMMX),ALPH(NATMMX),BET(NATMMX),IZ(NATMMX,3),NZ
 
      VARIED=.FALSE.
      ISRCH=1
      DO 30 I=1,NNCPL

        IF (.NOT. VARIED) THEN
          IF (ISTEPS(ISRCH) .EQ. ISTPMX(ISRCH)) THEN
10          ILINE=IVRLIN(ISRCH)
            ITYPE=IVARTP(ISRCH)
            ISTEPS(ISRCH)=1
            IF (INDEX(KEYWRD,'ZMAT') .GT. 0) THEN
              IF (ITYPE .EQ. 1) THEN
                BL(ILINE)=BL(ILINE)-DBLE(ISTPMX(ISRCH)-1)*VARINC(ISRCH)
              ELSE IF (ITYPE .EQ. 2) THEN
                ALPH(ILINE)=ALPH(ILINE)-
     .                      DBLE(ISTPMX(ISRCH)-1)*VARINC(ISRCH)
              ELSE
                BET(ILINE)=BET(ILINE)-
     .                     DBLE(ISTPMX(ISRCH)-1)*VARINC(ISRCH)
              ENDIF
            ELSE IF (INDEX(KEYWRD,'XYZ') .GT. 0) THEN
              C(ILINE,ITYPE)=C(ILINE,ITYPE)-
     .                       DBLE(ISTPMX(ISRCH)-1)*VARINC(ISRCH)
            ELSE
              IF (ILINE .GT. 0) THEN
                FC(ILINE,ITYPE)=FC(ILINE,ITYPE)-
     .                          DBLE(ISTPMX(ISRCH)-1)*VARINC(ISRCH)
              ELSE
                IF (ITYPE .EQ. 4) THEN
                  ALAT=ALAT-DBLE(ISTPMX(ISRCH)-1)*VARINC(ISRCH)
                ELSE IF (ITYPE .EQ. 5) THEN
                  BLAT=BLAT-DBLE(ISTPMX(ISRCH)-1)*VARINC(ISRCH)
                ELSE IF (ITYPE .EQ. 6) THEN
                  CLAT=CLAT-DBLE(ISTPMX(ISRCH)-1)*VARINC(ISRCH)
                ELSE IF (ITYPE .EQ. 7) THEN
                  ALPLAT=ALPLAT-DBLE(ISTPMX(ISRCH)-1)*VARINC(ISRCH)
                ELSE IF (ITYPE .EQ. 8) THEN
                  BETLAT=BETLAT-DBLE(ISTPMX(ISRCH)-1)*VARINC(ISRCH)
                ELSE IF (ITYPE .EQ. 9) THEN
                  GAMLAT=GAMLAT-DBLE(ISTPMX(ISRCH)-1)*VARINC(ISRCH)
                ELSE
                ENDIF
              ENDIF
            ENDIF
            ISRCH=ISRCH+1
            IF (LCOUPL(ISRCH)) GOTO 10
          ELSE
20          ILINE=IVRLIN(ISRCH)
            ITYPE=IVARTP(ISRCH)
            ISTEPS(ISRCH)=ISTEPS(ISRCH)+1
            IF (INDEX(KEYWRD,'ZMAT') .GT. 0) THEN
              IF (ITYPE .EQ. 1) THEN
                BL(ILINE)=BL(ILINE)+VARINC(ISRCH)
              ELSE IF (ITYPE .EQ. 2) THEN
                ALPH(ILINE)=ALPH(ILINE)+VARINC(ISRCH)
              ELSE
                BET(ILINE)=BET(ILINE)+VARINC(ISRCH)
              ENDIF
            ELSE IF (INDEX(KEYWRD,'XYZ') .GT. 0) THEN
              C(ILINE,ITYPE)=C(ILINE,ITYPE)+VARINC(ISRCH)
            ELSE
              IF (ILINE .GT. 0) THEN
                FC(ILINE,ITYPE)=FC(ILINE,ITYPE)+VARINC(ISRCH)
              ELSE
                IF (ITYPE .EQ. 4) THEN
                  ALAT=ALAT+VARINC(ISRCH)
                ELSE IF (ITYPE .EQ. 5) THEN
                  BLAT=BLAT+VARINC(ISRCH)
                ELSE IF (ITYPE .EQ. 6) THEN
                  CLAT=CLAT+VARINC(ISRCH)
                ELSE IF (ITYPE .EQ. 7) THEN
                  ALPLAT=ALPLAT+VARINC(ISRCH)
                ELSE IF (ITYPE .EQ. 8) THEN
                  BETLAT=BETLAT+VARINC(ISRCH)
                ELSE IF (ITYPE .EQ. 9) THEN
                  GAMLAT=GAMLAT+VARINC(ISRCH)
                ELSE
                ENDIF
              ENDIF
            ENDIF
            ISRCH=ISRCH+1
            IF (LCOUPL(ISRCH)) GOTO 20
            VARIED=.TRUE.
          ENDIF
        ENDIF
30    CONTINUE
 
      WRITE(IOUT,40) IVARY
40    FORMAT(//,2X,76('*'),//,2X,'Geometry variation #',I5,':')
 
      DO 70 I=1,NVARLN
        IF (.NOT. LCOUPL(I)) THEN
          ITYPE=IVARTP(I)
          ILINE=IVRLIN(I)
          IF (INDEX(KEYWRD,'ZMAT') .GT. 0) THEN
            IF (ITYPE .EQ. 1) THEN
              WRITE(IOUT,50) ILINE,BL(ILINE)
            ELSE IF (ITYPE .EQ. 2) THEN
              WRITE(IOUT,50) ILINE,ALPH(ILINE)
            ELSE
              WRITE(IOUT,50) ILINE,BET(ILINE)
            ENDIF
          ELSE IF (INDEX(KEYWRD,'XYZ') .GT. 0) THEN
            WRITE(IOUT,50) ILINE,C(ILINE,ITYPE)
          ELSE
            IF (ILINE .GT. 0) THEN
              WRITE(IOUT,50) ILINE,FC(ILINE,ITYPE)
            ELSE
              IF (ITYPE .EQ. 4) THEN
                WRITE(IOUT,60) 'a',ALAT
              ELSE IF (ITYPE .EQ. 5) THEN
                WRITE(IOUT,60) 'b',BLAT
              ELSE IF (ITYPE .EQ. 6) THEN
                WRITE(IOUT,60) 'c',CLAT
              ELSE IF (ITYPE .EQ. 7) THEN
                WRITE(IOUT,60) 'alpha',ALPLAT
              ELSE IF (ITYPE .EQ. 8) THEN
                WRITE(IOUT,60) 'beta',BETLAT
              ELSE IF (ITYPE .EQ. 9) THEN
                WRITE(IOUT,60) 'gamma',GAMLAT
              ELSE
              ENDIF
            ENDIF
          ENDIF
50        FORMAT(2X,'Line ',I3,': ',F10.5)
60        FORMAT(2X,'Lattice constant ',A,': ',F10.5)
        ENDIF
70    CONTINUE
 
      IF (INDEX(KEYWRD,'ZMAT') .GT. 0) CALL BUILDZ(C)
      IF (INDEX(KEYWRD,'FRACT') .GT. 0) CALL FTOCAR(C)
      CALL INMODI
 
      RETURN
      END
