C ********************************************************************
C * EHPC - Extended Hueckel properties calculations                  *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************
C ********************************************************************
C *                                                                  *
C *  GPROJF                                                          *
C *                                                                  *
C *  Routine of EHPC                                                 *
C *                                                                  *
C *  Usage......: Obtains information for FMOPOP projections.        *
C *                                                                  *
C *  Authors....: M.-H. Whangbo, Dept of Chem, North Carolina State  *
C *               University, Raleigh N.C.,                          *
C *               modified by M. Evain, Dept of Chemistry, North     *
C *               Carolina State University, Raleigh N.C.            *
C *  Date.......: 1981                                               *
C *  Revision...: Dec. 1987, 12.06.92/mbs (Martin Braendle c/o       *
C *               Calzaferri group, Inst. f. Inorg. and Phys. Chem.  *
C *               Freiestr. 3, CH-3012 Berne)                        *
C *  Remarks....: Slight modification of COMMON blocks.              *
C *                                                                  *
C *  Called from: PPART                                              *
C *                                                                  *
C *  Calls......: READA,WRITEL,READL                                 *
C *                                                                  *
C ********************************************************************

      SUBROUTINE GPROJF(NDIM)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      INCLUDE 'sizes'

      CHARACTER LINE*80,LL*131

      COMMON /AOPRF/IPROJF(NDIMMX,NFMOMX),NDPRF(NFMOMX),NPROJF
      COMMON /IOUNIT/IIN,IOUT,ISTART(40)

      COMMON /KEYWRD/KEYWRD,SLINE
      CHARACTER KEYWRD*320,SLINE*80

      COMMON /TIT1/NCARD(MXCARD),NCARDF(MXCARD),NCARDB(MXCARD)

      COMMON /TIT2/TITL(MXCARD,MXTITL),TITLF(MXCARD,MXTITL),
     .             TITLB(MXCARD,MXTITL)
      CHARACTER TITL*80,TITLF*80,TITLB*80

      NPROJF=0
      IF (INDEX(SLINE,'FMOPROJ') .EQ. 0) THEN
        LINE='Cards FMOPROJ expected.'
        CALL WRITEL (LINE)
        RETURN
      ENDIF
      WRITE(IOUT,10)
   10 FORMAT(' ')

   20 IF (INDEX(SLINE,'FMOPROJ') .EQ. 0) GOTO 130
      NPROJF=NPROJF+1
      IF (NPROJF .GT. NFMOMX) THEN
        LINE='Number of projectios limited.'
        CALL WRITEL(LINE)
      ENDIF
      DO 30 I=1,NDIM
        IPROJF(I,NPROJF)=0
   30 CONTINUE
   40 IF (INDEX(SLINE,'FMOPROJ') .EQ. 0) GOTO 110
      NUMPRO=INT(READA(SLINE,8,80))
      IF (NUMPRO .NE. NPROJF) GOTO 110
      NCARDF(NPROJF)=NCARDF(NPROJF)+1
      TITLF(NPROJF,NCARDF(NPROJF))=SLINE(9:80)
      I=2
   50 IONLY=1
      ISEP=0
      IP1=ISTART(I)
      NR1=INT(READA(SLINE,IP1,80))
      IP2=ISTART(I+1)
      IF (SLINE(IP2:IP2) .EQ. '-') THEN
        IONLY=0
        ISEP=1
        NR2=INT(READA(SLINE,IP2+1,80))
        GOTO 70
      ENDIF
      DO 60 J=IP1+1,IP2
        IF (SLINE(J-1:J-1) .EQ. '-') THEN
          NR2=INT(READA(SLINE,J,80))
          IONLY=0
          GOTO 70
        ENDIF
   60 CONTINUE
   70 IF (IONLY .EQ. 1) THEN
        IPROJF(NR1,NPROJF)=1
        I=I+1
      ELSE
        DO 80 J=NR1,NR2
          IPROJF(J,NPROJF)=1
   80   CONTINUE
        I=I+1
        IF (ISEP .EQ. 1) I=I+1
      ENDIF
      IF (ISTART(I) .LT. 80) GOTO 50

      LL=' FMOPROJ # '
      DO 90 I=8,80
        J=I+4
        LL(J:J)=SLINE(I:I)
   90 CONTINUE
      WRITE(IOUT,100) LL
  100 FORMAT(1X,A)
      CALL READL
      GOTO 40

  110 NDP=0
      IJK=0
      DO 120 I=1,NDIM
        IF (IPROJF(I,NPROJF) .EQ. 1) THEN
          IJK=IJK+1
          IPROJF(IJK,NPROJF)=I
          NDP=NDP+1
        ENDIF
  120 CONTINUE
      NDPRF(NPROJF)=NDP
      IF (NDP .EQ. 0) THEN
        SLINE='No FMOs!'
        CALL WRITEL(SLINE)
      ENDIF

      GOTO 20
  130 CONTINUE
      WRITE(IOUT,10)

      RETURN
      END
